******************************
* Super Spool Desk Accessory *
*            by              *
*        Kirk Stover         *
******************************

            text

*--------------------------

gemdos      equ 1
bios        equ 13
xbios       equ 14

*--------------------------

nrObjects   equ 22
ixObjects   equ 320
nrTrees     equ 1
ixTrees     equ 848
nrTedInfos  equ 5
ixTedInfos  equ 180

*--------------------------
* Resource Object Indexes

SERIAL      equ 15
PARALLEL    equ 14
TURNON      equ 17
ABORT       equ 19
TURNOFF     equ 18
CANCEL      equ 20
OK          equ 21
TREE        equ 0
BUFFVAL     equ 7
BUFFDOWN    equ 6
BUFFUP      equ 8
SPEDVAL     equ 11
SPEDDOWN    equ 10
SPEDUP      equ 12

*--------------------------

start       move.l   #new_stack,sp
            bsr      main
            move.w   #0,-(sp)
            trap     #gemdos

*--------------------------

call_aes    move.l   #aespb,d1
            move.w   #$c8,d0
            trap     #2
            rts

*--------------------------

call_vdi    move.l   #vdipb,d1
            move.w   #$73,d0
            trap     #2
            rts

*--------------------------

appl_init   move.w   #10,opcode
            move.w   #0,sintin
            move.w   #1,sintout
            move.w   #0,saddrin
            move.w   #0,saddrout
            bsr      call_aes
            move.w   intout,appl_id
            rts

*--------------------------

graf_handle move.w   #77,opcode
            move.w   #0,sintin
            move.w   #5,sintout
            move.w   #0,saddrin
            move.w   #0,saddrout
            bsr      call_aes
            move.w   intout,gr_handle
            rts

*--------------------------

wind_update move.w   #107,opcode
            move.w   #1,sintin
            move.w   #1,sintout
            move.w   #0,saddrin
            move.w   #0,saddrout
            move.w   d0,intin
            bsr      call_aes
            rts

*--------------------------

objc_draw   move.w   #42,opcode
            move.w   #6,sintin
            move.w   #1,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.w   start_obj,intin
            move.w   #10,intin+2
            move.w   x,intin+4
            move.w   y,intin+6
            move.w   w,intin+8
            move.w   h,intin+10
            move.l   tree_addr,addrin
            bsr      call_aes
            move.w   intout,d0
            rts

*--------------------------

form_do     move.w   #50,opcode
            move.w   #1,sintin
            move.w   #1,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.w   #0,intin
            move.l   tree_addr,addrin
            bsr      call_aes
            move.w   intout,d0
            rts

*--------------------------

form_dial   move.w   #51,opcode
            move.w   #9,sintin
            move.w   #1,sintout
            move.w   #0,saddrin
            move.w   #0,saddrout
            move.w   d0,intin
            move.w   #0,intin+2
            move.w   #0,intin+4
            move.w   #0,intin+6
            move.w   #0,intin+8
            move.w   x,intin+10
            move.w   y,intin+12
            move.w   w,intin+14
            move.w   h,intin+16
            bsr      call_aes
            move.w   intout,d0
            rts

*--------------------------

form_alert  move.w   #52,opcode
            move.w   #1,sintin
            move.w   #1,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.w   d0,intin
            move.l   a0,addrin
            bsr      call_aes
            move.w   intout,d0
            rts

*--------------------------

form_center move.w   #54,opcode
            move.w   #0,sintin
            move.w   #5,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.l   tree_addr,addrin
            bsr      call_aes
            move.w   intout+2,x
            move.w   intout+4,y
            move.w   intout+6,w
            move.w   intout+8,h
            rts

*--------------------------

menu_register move.w #35,opcode
            move.w   #1,sintin
            move.w   #1,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.w   appl_id,intin
            move.l   #spool_title,addrin
            bsr      call_aes
            move.w   intout,menu_id
            rts

*--------------------------

evnt_multi  move.w   #25,opcode
            move.w   #16,sintin
            move.w   #7,sintout
            move.w   #1,saddrin
            move.w   #0,saddrout
            move.w   #$0010,intin         ; message event
            tst.w    print_flag
            beq      evnt_mult_1
            tst.w    spool_flag
            beq      evnt_mult_1
            ori.w    #$0020,intin         ; timer event
evnt_mult_1 move.w   #0,intin+2
            move.w   #0,intin+4
            move.w   #0,intin+6
            move.w   #0,intin+8
            move.w   #0,intin+10
            move.w   #0,intin+12
            move.w   #0,intin+14
            move.w   #0,intin+16
            move.w   #0,intin+18
            move.w   #0,intin+20
            move.w   #0,intin+22
            move.w   #0,intin+24
            move.w   #0,intin+26
            move.l   #4000,d0
            divs     old_spedval,d0
            move.w   d0,intin+28
            move.w   #0,intin+30
            move.l   #msg_buff,addrin
            bsr      call_aes
            move.w   intout,d0
            rts

*--------------------------

get_resolut move.w   #4,-(sp)
            trap     #xbios
            addq.l   #2,sp
            move.w   #16,height
            cmp.w    #2,d0
            beq      get_resol_x
            move.w   #8,height
get_resol_x rts

*--------------------------

fix_rsrc    move.l   #resource,a0         ; fix tree index
            add.l    #ixTrees,a0
            add.l    #resource,(a0)
            move.l   (a0),tree_addr
            move.l   #resource,a0         ; fix tedinfos
            add.l    #ixTedInfos,a0
            move.w   #nrTedInfos,d0
            sub.w    #1,d0
fix_rsrc_1  add.l    #resource,0(a0)      ; ptext
            add.l    #resource,4(a0)      ; ptmplt
            add.l    #resource,8(a0)      ; pvalid
            add.l    #28,a0
            dbra     d0,fix_rsrc_1
            move.l   #resource,a0         ; fix objects
            add.l    #ixObjects,a0
            move.w   #nrObjects,d0
            sub.w    #1,d0
fix_rsrc_2  cmp.w    #20,6(a0)            ; gbox
            beq      fix_rsrc_3
            cmp.w    #24,6(a0)            ; gprogdef
            beq      fix_rsrc_3
            cmp.w    #25,6(a0)            ; gibox
            beq      fix_rsrc_3
            cmp.w    #27,6(a0)            ; gboxchar
            beq      fix_rsrc_3
            add.l    #resource,12(a0)     ; fix specs
fix_rsrc_3  move.w   16(a0),d1
            mulu     #8,d1
            move.w   d1,16(a0)            ; fix x coordinate
            move.w   18(a0),d1
            mulu     height,d1
            move.w   d1,18(a0)            ; fix y coordinate
            move.w   20(a0),d1
            mulu     #8,d1
            move.w   d1,20(a0)            ; fix width
            move.w   22(a0),d1
            mulu     height,d1
            move.w   d1,22(a0)            ; fix height
            add.l    #24,a0
            dbra     d0,fix_rsrc_2
            move.l   tree_addr,a0
            move.w   #BUFFVAL,d0
            mulu     #24,d0
            add.w    d0,a0
            move.l   12(a0),a0
            move.l   (a0),buffval_adr
            move.l   tree_addr,a0
            move.w   #SPEDVAL,d0
            mulu     #24,d0
            add.w    d0,a0
            move.l   12(a0),a0
            move.l   (a0),spedval_adr
            rts

*--------------------------

select      move.l   tree_addr,a0
            mulu     #24,d0
            add.w    d0,a0
            or.w     #0001,10(a0)
            rts

*--------------------------

deselect    move.l   tree_addr,a0      ; point to the dialog
            mulu     #24,d0            ; calculate object offset
            add.w    d0,a0             ; add to pointer
            and.w    #$fffe,10(a0)     ; turn off selected bit
            rts                        ; return

*--------------------------

nodisable   move.l   tree_addr,a0
            mulu     #24,d0
            add.w    d0,a0
            and.w    #$fff7,10(a0)
            rts

*--------------------------

disable     move.l   tree_addr,a0
            mulu     #24,d0
            add.w    d0,a0
            or.w     #$0008,10(a0)
            rts

*--------------------------

get_select  move.l   tree_addr,a0
            mulu     #24,d0
            add.w    d0,a0
            move.w   10(a0),d0
            and.w    #$0001,d0
            tst.w    d0
            rts

*--------------------------

button_stat move.w   #CANCEL,d0
            bsr      deselect
            move.w   #OK,d0
            bsr      deselect
            move.w   #PARALLEL,d0
            bsr      nodisable
            move.w   #SERIAL,d0
            bsr      nodisable
            move.w   #TURNON,d0
            bsr      nodisable
            move.w   #TURNOFF,d0
            bsr      nodisable
            move.w   #ABORT,d0
            bsr      nodisable
            tst.w    spool_flag
            bne      butt_stat_1
            move.w   #ABORT,d0
            bsr      disable
            bra      butt_stat_x
butt_stat_1 tst.w    print_flag
            bne      butt_stat_2
            move.w   #ABORT,d0
            bsr      disable
            bra      butt_stat_x
butt_stat_2 move.w   #TURNOFF,d0
            bsr      disable
            move.w   #PARALLEL,d0
            bsr      disable
            move.w   #SERIAL,d0
            bsr      disable
butt_stat_x rts

*--------------------------

load_parm   move.l   #old_parm,a0
            move.l   #new_parm,a1
            move.w   (a0)+,(a1)+
            move.w   (a0)+,(a1)+
            move.w   (a0),(a1)
            move.l   buffval_adr,a0
            move.w   new_buffval,d0
            bsr      bin_to_dec
            move.l   spedval_adr,a0
            move.w   new_spedval,d0
            bsr      bin_to_dec
            move.w   #PARALLEL,d0
            bsr      deselect
            move.w   #SERIAL,d0
            bsr      deselect
            move.w   new_printer,d0
            bsr      select
            move.w   #TURNON,d0
            bsr      deselect
            move.w   #TURNOFF,d0
            bsr      deselect
            move.w   #ABORT,d0
            bsr      deselect
            move.w   #TURNON,d0
            tst.w    spool_flag
            bne      load_parm_1
            move.w   #TURNOFF,d0
load_parm_1 bsr      select
            tst.w    spool_flag
            beq      load_parm_x
            tst.w    print_flag
            bne      load_parm_x
            move.l   buff_beg,-(sp)
            move.w   #$49,-(sp)
            trap     #gemdos
            addq.l   #6,sp
load_parm_x rts

*--------------------------

save_parm   move.w   #PARALLEL,d0
            move.w   d0,new_printer
            bsr      get_select
            bne      save_parm_1
            move.w   #SERIAL,new_printer
save_parm_1 move.w   #TURNON,d0
            bsr      get_select
            bne      save_parm_3
            move.w   #TURNOFF,d0
            bsr      get_select
            beq      save_parm_2
            tst.w    spool_flag
            beq      save_parm_5
            move.w   #0,spool_flag
            move.l   trap13_save,-(sp)
            move.w   #45,-(sp)
            move.w   #5,-(sp)
            trap     #bios
            addq.l   #8,sp
            bra      save_parm_5
save_parm_2 move.w   #0,print_flag
            move.l   buff_beg,head_ptr
            move.l   buff_beg,tail_ptr
            bra      save_parm_5
save_parm_3 tst.w    print_flag
            bne      save_parm_5
            move.w   new_buffval,d0
            mulu     #$0400,d0
            move.l   d0,buff_end
            move.l   d0,-(sp)
            move.w   #$48,-(sp)
            trap     #gemdos
            addq.l   #6,sp
            tst.l    d0
            bpl      save_parm_4
            bsr      ring_bell
            move.l   #buff_alert,a0
            move.w   #1,d0
            bsr      form_alert
            addq.l   #4,sp
            bra      do_dial_1
save_parm_4 move.l   d0,buff_beg
            move.l   d0,head_ptr
            move.l   d0,tail_ptr
            add.l    d0,buff_end
            tst.w    spool_flag
            bne      save_parm_5
            move.w   #1,spool_flag
            move.l   #bios_trap,-(sp)
            move.w   #45,-(sp)
            move.w   #5,-(sp)
            trap     #bios
            addq.l   #8,sp
            move.l   d0,trap13_save
save_parm_5 move.l   #new_parm,a0
            move.l   #old_parm,a1
            move.w   (a0)+,(a1)+
            move.w   (a0)+,(a1)+
            move.w   (a0),(a1)
            rts

*--------------------------

do_dialog   bsr      form_center
            move.w   #0,d0
            bsr      form_dial
            move.w   #1,d0
            bsr      form_dial
            bsr      load_parm
do_dial_1   move.w   #0,start_obj
            bsr      button_stat
do_dial_2   bsr      objc_draw
do_dial_3   bsr      form_do
            cmp.w    #BUFFDOWN,d0
            bne      do_dial_4
            bsr      buffer_down
            bra      do_dial_2
do_dial_4   cmp.w    #BUFFUP,d0
            bne      do_dial_5
            bsr      buffer_up
            bra      do_dial_2
do_dial_5   cmp.w    #SPEDDOWN,d0
            bne      do_dial_6
            bsr      speed_down
            bra      do_dial_2
do_dial_6   cmp.w    #SPEDUP,d0
            bne      do_dial_7
            bsr      speed_up
            bra      do_dial_2
do_dial_7   cmp.w    #CANCEL,d0
            beq      do_dial_8
            cmp.w    #OK,d0
            bne      do_dial_3
            bsr      save_parm
do_dial_8   move.w   #2,d0
            bsr      form_dial
            move.w   #3,d0
            bsr      form_dial
            rts

*--------------------------

bin_to_dec  add.l    #4,a0
            move.w   #2,d1
bin_dec_1   ext.l    d0
            divs     #10,d0
            swap     d0
            move.b   d0,-(a0)
            add.b    #'0',(a0)
            swap     d0
            dbra     d1,bin_dec_1
            rts

*--------------------------

ring_bell   move.w   #7,-(sp)
            move.w   #2,-(sp)
            trap     #gemdos
            addq.l   #4,sp
            rts

*--------------------------

buffer_down move.w   #BUFFVAL,start_obj
            tst.w    print_flag
            bne      ring_bell
            move.w   new_buffval,d0
            sub.w    #1,d0
            beq      buff_down_x
            move.w   d0,new_buffval
            move.l   buffval_adr,a0
            bsr      bin_to_dec
buff_down_x rts

*--------------------------

buffer_up   move.w   #BUFFVAL,start_obj
            tst.w    print_flag
            bne      ring_bell
            add.w    #1,new_buffval
            move.w   new_buffval,d0
            mulu     #$400,d0
            move.l   d0,-(sp)
            move.l   #-1,-(sp)
            move.w   #$48,-(sp)
            trap     #gemdos
            addq.l   #6,sp
            move.l   (sp)+,d1
            cmp.l    d0,d1
            bhi      buff_up_1
            move.w   new_buffval,d0
            move.l   buffval_adr,a0
            bsr      bin_to_dec
            bra      buff_up_x
buff_up_1   sub.w    #1,new_buffval
            move.l   #buff_alert,a0
            move.w   #1,d0
            bsr      form_alert
buff_up_x   rts

*--------------------------

speed_down  move.w   new_spedval,d0
            sub.w    #10,d0
            beq      speed_down_x
            move.w   d0,new_spedval
            move.l   spedval_adr,a0
            bsr      bin_to_dec
speed_down_x move.w   #SPEDVAL,start_obj
            rts

*--------------------------

speed_up    move.w   new_spedval,d0
            add.w    #10,d0
            cmp.w    #300,d0
            bgt      speed_up_x
            move.w   d0,new_spedval
            move.l   spedval_adr,a0
            bsr      bin_to_dec
speed_up_x  move.w   #SPEDVAL,start_obj
            rts

*--------------------------

main        bsr      appl_init
            bsr      graf_handle
            bsr      menu_register
            bsr      get_resolut
            bsr      fix_rsrc
loop        bsr      evnt_multi
            move.w   d0,d1
            and.w    #$0010,d1
            cmp.w    #$0010,d1
            beq      do_msg
            and.w    #$0020,d0
            cmp.w    #$0020,d0
            bne      loop
do_print    bsr      print
            bsr      print
            bsr      print
            bsr      print
            bra      loop
do_msg      cmp.w    #$28,msg_buff     ; does accessory want to open?
            bne      loop
            move.w   msg_buff+8,d0
            cmp.w    menu_id,d0        ; is it our accessory?
            bne      loop
            move.w   #1,d0
            bsr      wind_update
            bsr      do_dialog         ; go do the dialog
            move.w   #0,d0
            bsr      wind_update
            bra      loop

*--------------------------

print       tst.w    print_flag
            beq      print_x
            move.l   head_ptr,a3
            addq.l   #1,a3
            cmp.l    buff_end,a3
            bne      print_1
            move.l   buff_beg,a3
print_1     cmp.l    tail_ptr,a3
            bne      print_2
            move.w   #0,print_flag
            bra      print_x
print_2     bsr      spool_stat
            beq      print_x
            move.l   a3,head_ptr
            move.b   (a3),d0
            bsr      spool_out
print_x     rts

*--------------------------

spool_stat  move.w   #$ffff,-(sp)         ; spool device
            move.w   #8,-(sp)             ; bconstat
            trap     #bios
            addq.l   #4,sp
            tst.w    d0
            rts

*--------------------------

spool_out   and.w    #$00ff,d0
            move.w   d0,-(sp)
            move.w   #$ffff,-(sp)         ; spool device
            move.w   #3,-(sp)             ; bconout
            trap     #bios
            addq.l   #6,sp
            rts

*--------------------------

bios_trap   move.l   sp,a1
            btst     #5,(sp)
            bne      bios_trap_1
            move.l   usp,a1
            subq.w   #6,a1
bios_trap_1 cmp.w    #3,6(a1)       ; BCONOUT?
            bne      bios_trap_3
            move.w   8(a1),d0
            cmp.w    device,d0
            bne      bios_trap_2
            move.w   10(a1),d0
            bra      load_buffer
bios_trap_2 cmp.w    #$ffff,d0      ; spool device?
            bne      trap_13
            move.w   device,8(a1)
            bra      trap_13
bios_trap_3 cmp.w    #8,6(a1)       ; BCONSTAT?
            bne      trap_13
            move.w   8(a1),d0
            cmp.w    device,d0
            bne      bios_trap_5
            move.l   tail_ptr,a0
            addq.l   #1,a0
            cmp.l    buff_end,a0
            bne      bios_trap_4
            move.l   buff_beg,a0
bios_trap_4 moveq.l  #-1,d0
            cmp.l    head_ptr,a0
            bne      bios_trap_x
            moveq.l  #0,d0
            bra      bios_trap_x
bios_trap_5 cmp.w    #$ffff,d0      ; spool device?
            bne      trap_13
            move.w   device,8(a1)
            bra      trap_13
bios_trap_x rte

*--------------------------

trap_13     move.l   trap13_save,a0
            jmp      (a0)

*--------------------------

load_buffer tst.w    print_flag
            bne      load_buff_1
            move.l   buff_beg,head_ptr
            move.l   buff_beg,tail_ptr
load_buff_1 move.l   tail_ptr,a0
            addq.l   #1,a0
            cmp.l    buff_end,a0
            bne      load_buff_2
            move.l   buff_beg,a0
load_buff_2 cmp.l    head_ptr,a0
            bne      load_buff_4
            move.l   head_ptr,a2
            addq.l   #1,a2
            cmp.l    buff_end,a2
            bne      load_buff_3
            move.l   buff_beg,a2
load_buff_3 move.b   (a2),d1
            move.l   a2,head_ptr
            move.w   d1,10(a1)
            move.w   device,8(a1)
            move.l   a0,tail_ptr
            move.b   d0,(a0)
            bra      trap_13
load_buff_4 move.l   a0,tail_ptr
            move.b   d0,(a0)
            move.w   #1,print_flag
            moveq.l  #-1,d0
load_buff_x rte

*--------------------------

gr_handle   ds.w  1
appl_id     ds.w  1
menu_id     ds.w  1
tree_addr   ds.l  1
start_obj   ds.w  1
print_flag  dc.w  0
spool_flag  dc.w  0
device      ds.w  1
height      ds.w  1
x           ds.w  1
y           ds.w  1
w           ds.w  1
h           ds.w  1
msg_buff    ds.w  8
buffval_adr ds.l  1
spedval_adr ds.l  1
buff_beg    dc.l  0
head_ptr    ds.l  1
tail_ptr    ds.l  1
buff_end    ds.l  1
trap13_save ds.l  1

old_parm    ds.w  0
old_buffval dc.w  8
old_spedval dc.w  100
old_printer dc.w  PARALLEL

new_parm    ds.w  0
new_buffval ds.w  1
new_spedval ds.w  1
new_printer ds.w  1

spool_title dc.b  '  Super Spool',0

buff_alert  dc.b  '[3][There is not enough|'
            dc.b  'memory available for|'
            dc.b  'the buffer.  Please|'
            dc.b  'change the size.][OK]',0

aespb       dc.l  contrl,global,intin,intout,addrin,addrout
vdipb       dc.l  contrl,intin,ptsin,intout,ptsout


contrl      ds.w  0
opcode      ds.w  1
sintin      ds.w  1
sintout     ds.w  1
saddrin     ds.w  1
saddrout    ds.w  1

global      ds.w  0
apversion   ds.w  1
apcount     ds.w  1
apid        ds.w  1
apprivate   ds.l  1
apptree     ds.l  1
ap1resv     ds.l  1
ap2resv     ds.l  1
ap3resv     ds.l  1
ap4resv     ds.l  1

intin       ds.w  128
ptsin       ds.w  128
intout      ds.w  128
ptsout      ds.w  128
addrin      ds.w  128
addrout     ds.w  128

            ds.l  200
new_stack   ds.l  1

resource    ds.w 0
            dc.w $0000,$0140,$00B4,$00B4,$00B4,$00B4,$0024,$00B4
            dc.w $00B4,$0350,$0016,$0001,$0005,$0000,$0000,$0000
            dc.w $0000,$0354,$2062,$7920,$4B69,$726B,$2053,$746F
            dc.w $7665,$7220,$0000,$200E,$0F20,$5375,$7065,$7220
            dc.w $5370,$6F6F,$6C20,$5631,$2E30,$3020,$0E0F,$2000
            dc.w $4275,$6666,$6572,$2053,$697A,$6520,$284B,$293A
            dc.w $2000,$0020,$3030,$3820,$0000,$5072,$696E,$7465
            dc.w $7220,$5370,$6565,$643A,$2000,$0020,$3130,$3020
            dc.w $0000,$5061,$7261,$6C6C,$656C,$0053,$6572,$6961
            dc.w $6C00,$2020,$4F6E,$2020,$2000,$2020,$4F66,$6620
            dc.w $2020,$0041,$626F,$7274,$0043,$414E,$4345,$4C00
            dc.w $4F4B,$0000,$0000,$0024,$0000,$0000,$0000,$0035
            dc.w $0005,$0006,$0000,$1121,$0000,$0000,$0011,$0001
            dc.w $0000,$0050,$0000,$0000,$0000,$0062,$0003,$0006
            dc.w $0000,$1180,$0000,$00FF,$0012,$0001,$0000,$0063
            dc.w $0000,$0000,$0000,$0069,$0003,$0006,$0000,$1180
            dc.w $0000,$00FF,$0006,$0001,$0000,$006A,$0000,$0000
            dc.w $0000,$007A,$0003,$0006,$0000,$1180,$0000,$00FF
            dc.w $0010,$0001,$0000,$007B,$0000,$0000,$0000,$0081
            dc.w $0003,$0006,$0000,$1180,$0000,$00FF,$0006,$0001
            dc.w $FFFF,$0001,$0004,$0014,$0000,$0020,$0001,$1161
            dc.w $0000,$0000,$0026,$0014,$0004,$0002,$0003,$0014
            dc.w $0000,$0000,$00FE,$1100,$0002,$0001,$0022,$0003
            dc.w $0003,$FFFF,$FFFF,$0015,$0000,$0000,$0000,$00B4
            dc.w $000B,$0002,$000C,$0001,$0001,$FFFF,$FFFF,$001C
            dc.w $0000,$0000,$0000,$0036,$0004,$0001,$0019,$0001
            dc.w $0000,$0005,$0015,$0014,$0000,$0000,$00FE,$1100
            dc.w $0002,$0005,$0022,$000E,$0006,$FFFF,$FFFF,$0015
            dc.w $0000,$0000,$0000,$00D0,$0002,$0001,$0011,$0001
            dc.w $0007,$FFFF,$FFFF,$001B,$0040,$0000,$02FF,$1100
            dc.w $0013,$0001,$0004,$0001,$0008,$FFFF,$FFFF,$0016
            dc.w $0000,$0000,$0000,$00EC,$0017,$0001,$0005,$0001
            dc.w $0009,$FFFF,$FFFF,$001B,$0040,$0000,$01FF,$1100
            dc.w $001C,$0001,$0004,$0001,$000A,$FFFF,$FFFF,$0015
            dc.w $0000,$0000,$0000,$0108,$0002,$0003,$000F,$0001
            dc.w $000B,$FFFF,$FFFF,$001B,$0040,$0000,$02FF,$1100
            dc.w $0013,$0003,$0004,$0001,$000C,$FFFF,$FFFF,$0016
            dc.w $0000,$0000,$0000,$0124,$0017,$0003,$0005,$0001
            dc.w $000D,$FFFF,$FFFF,$001B,$0040,$0000,$01FF,$1100
            dc.w $001C,$0003,$0004,$0001,$0010,$000E,$000F,$0014
            dc.w $0000,$0000,$00FF,$1100,$0002,$0005,$001E,$0003
            dc.w $000F,$FFFF,$FFFF,$001A,$0011,$0000,$0000,$0082
            dc.w $0005,$0001,$0008,$0001,$000D,$FFFF,$FFFF,$001A
            dc.w $0011,$0000,$0000,$008B,$0011,$0001,$0008,$0001
            dc.w $0014,$0011,$0013,$0014,$0000,$0000,$00FF,$1100
            dc.w $0002,$0008,$001E,$0003,$0012,$FFFF,$FFFF,$001A
            dc.w $0011,$0000,$0000,$0092,$0001,$0001,$0008,$0001
            dc.w $0013,$FFFF,$FFFF,$001A,$0011,$0000,$0000,$009A
            dc.w $000B,$0001,$0008,$0001,$0010,$FFFF,$FFFF,$001A
            dc.w $0011,$0000,$0000,$00A3,$0015,$0001,$0008,$0001
            dc.w $0015,$FFFF,$FFFF,$001A,$0015,$0000,$0000,$00A9
            dc.w $0007,$000C,$0008,$0001,$0004,$FFFF,$FFFF,$001A
            dc.w $0037,$0000,$0000,$00B0,$0013,$000C,$0008,$0001
            dc.w $0000,$0140

            end

